---
title: Credential Management API
slug: Web/API/Credential_Management_API
tags:
  - API
  - Credential Management API
  - Landing
  - NeedsContent
  - Overview
  - Reference
  - credential management
---
<p>{{DefaultAPISidebar("Credential Management API")}}{{ SeeCompatTable() }}</p>

<p class="summary">The Credential Management API lets a website store and retrieve password, public key, and federated credentials. These capabilities allow users to sign in without typing passwords, see the federated account they used to sign in to a site, and resume a session without the explicit sign-in flow of an expired session.</p>

<h2 id="Credential_management_concepts_and_usage">Credential management concepts and usage</h2>

<p>This API lets websites interact with a user agent’s password system directly so that websites can deal in a uniform way with site credentials and user agents can provide better assistance with the management of their credentials. For example, user agents have a particularly hard time dealing with federated identity providers or esoteric sign-in mechanisms.</p>

<p>To address these problems, the Credential Management API provides ways for a website to store and retrieve different types of credentials. This gives users capabilities such as seeing the federated account they used to sign on to a site, or resuming a session without the explicit sign-in flow of an expired session.</p>

<div class="note">
<p>This API is restricted to top-level contexts. Calls to <code>get()</code> and <code>store()</code> within an <code>&lt;iframe&gt;</code> element will resolve without effect.</p>
</div>

<h3 id="Subdomain-shared_credentials">Subdomain-shared credentials</h3>

<p>Later version of the spec allow credentials to be retrieved from a different subdomain. For example, a password stored in <code>login.example.com</code> may be used to log in to <code>www.example.com</code>. To take advantage of this, a password must be explicitly stored by calling {{domxref("CredentialsContainer.store()")}}. This is sometimes referred to as public suffix list (PSL) matching; however the spec only <em>recommends</em> using PSL to determine the effective scope of a credential. It does not require it. Hence browsers may vary in their implementation.</p>

<h2 id="Interfaces">Interfaces</h2>

<dl>
 <dt>{{domxref("Credential")}}</dt>
 <dd>Provides information about an entity as a prerequisite to a trust decision.</dd>
 <dt>{{domxref("CredentialsContainer")}}</dt>
 <dd>Exposes methods to request credentials and notify the user agent when interesting events occur such as successful sign in or sign out. This interfaces is accessible from <code>navigator.credentials</code>.</dd>
 <dt>{{domxref("FederatedCredential")}}</dt>
 <dd>Provides information about credentials from a federated identity provider, which is an entity that a website trusts to correctly authenticate a user, and which provides an API for that purpose. <a href="http://openid.net/developers/specs/">OpenID Connect</a> is an example of such a framework.</dd>
 <dt>{{domxref("PasswordCredential")}}</dt>
 <dd>Provides information about a username/password pair.</dd>
 <dt>{{domxref("PublicKeyCredential")}}</dt>
 <dd>Provides a credential for logging in using a more secure system based on asymmetric cryptography instead of a password.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Credential Management')}}</td>
   <td>{{Spec2('Credential Management')}}</td>
   <td>Initial definition.</td>
  </tr>
  <tr>
   <td>{{SpecName('WebAuthn')}}</td>
   <td>{{Spec2('WebAuthn')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>
